#!/bin/bash

# -------------------------------------------------------------------------- #
# Copyright 2002-2019, OpenNebula Project, OpenNebula Systems                #
#                                                                            #
# Licensed under the Apache License, Version 2.0 (the "License"); you may    #
# not use this file except in compliance with the License. You may obtain    #
# a copy of the License at                                                   #
#                                                                            #
# http://www.apache.org/licenses/LICENSE-2.0                                 #
#                                                                            #
# Unless required by applicable law or agreed to in writing, software        #
# distributed under the License is distributed on an "AS IS" BASIS,          #
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   #
# See the License for the specific language governing permissions and        #
# limitations under the License.                                             #
#--------------------------------------------------------------------------- #

source $(dirname $0)/../../etc/vmm/kvm/kvmrc
source $(dirname $0)/../../scripts_common.sh

DOMAIN=$1
MAC=$2

DETACH_ARGS="--domain $DOMAIN --type bridge --mac $MAC"

function is_attached
{
    virsh --connect $LIBVIRT_URI domiflist $DOMAIN | grep $MAC > /dev/null 2>&1
}

function detach_nic
{
    exec_and_log "virsh --connect $LIBVIRT_URI detach-interface $DETACH_ARGS" \
        "Could not detach NIC ($MAC) from $DOMAIN" || return 1

    if is_attached; then
        return 1
    else
        return 0
    fi
}

if ! retry ${VIRSH_RETRIES:-3} detach_nic; then
    exit 1
fi
